IF EXISTS(SELECT NAME
            FROM SYSOBJECTS
           WHERE NAME = 'CTB_PAG_LANC' AND TYPE = 'P')
   DROP PROCEDURE CTB_PAG_LANC
GO

CREATE PROCEDURE CTB_PAG_LANC
   @P_NRLANCCTBTEMP  VARCHAR(12),
   @P_CDFILIAL       VARCHAR(04),
   @P_NRLANCTONF     VARCHAR(10),
   @P_NRPARCELAPAG   VARCHAR(02),
   @P_NRSEQVENPAG    VARCHAR(02),
   @P_DTAJUSTEPAG    DATETIME,
   @P_CDAJUCTPAG     VARCHAR(04),
   @P_IDTIPO         VARCHAR(01),
   @P_NRLANCCTB      VARCHAR(12) OUTPUT
AS
   /* VARIAVEIS DO CURSOR C_CONTAS */
   DECLARE @C_CONTAS_CDEMPRESA VARCHAR(02);
   DECLARE @C_CONTAS_CDTPCTPAGAR VARCHAR(06);
   DECLARE @C_CONTAS_CDFILIRECE VARCHAR(04);
   DECLARE @C_CONTAS_CDFORNECED VARCHAR(21);
   DECLARE @C_CONTAS_NRNOTAFISC VARCHAR(20);
   DECLARE @C_CONTAS_DTENTRSAID DATETIME;
   DECLARE @C_CONTAS_VRORIGPAG FLOAT;
   DECLARE @C_CONTAS_IDSTATUS VARCHAR(01);
   DECLARE @C_CONTAS_CDHISTPADR VARCHAR(04);
   DECLARE @C_CONTAS_CDCONTCTBL VARCHAR(20);
   DECLARE @C_CONTAS_VRATUAPAG FLOAT;
   
   DECLARE @V_CONTRAT VARCHAR(01);
   DECLARE @V_NRLANCTEMP VARCHAR(20);

   DECLARE @V_DATAAUX VARCHAR(20);
   DECLARE @V_CDHISTPADR VARCHAR(04);
   DECLARE @V_DSHISTLANC VARCHAR(200);
   DECLARE @V_CDCONTCTBL VARCHAR(20);
   DECLARE @V_IDTIPOCOME VARCHAR(01);
   DECLARE @V_IDCONTCCUS VARCHAR(01);
   DECLARE @V_CDFORNECEDAUX VARCHAR(21);

   DECLARE @V_CDCENTCUST VARCHAR(04);
   DECLARE @V_CDFILIAL VARCHAR(04);
   DECLARE @V_VRRATEIO FLOAT;
   DECLARE @V_RATSEQ INT;
   DECLARE @V_ENTROULOOP VARCHAR(01);
   DECLARE @V_INPARTIDA INT;
   DECLARE @V_INCOUNT INT;
   DECLARE @V_TOTAL FLOAT;
   DECLARE @V_PERCENTUAL FLOAT;
   DECLARE @V_SEQUENCIAL VARCHAR(05);



   /* VARIAVEIS DO CURSOR C_RATCTPAGAR */
   DECLARE @C_RATCTPAGAR_CDCENTCUST   VARCHAR(04);
   DECLARE @C_RATCTPAGAR_CDFIRATCTPAG VARCHAR(04);
   DECLARE @C_RATCTPAGAR_VRRATCCCTPAG FLOAT;
   DECLARE @C_RATCTPAGAR_RECORDCOUNT  INT;


   DECLARE @V_RATSEQAUX VARCHAR(05);
   DECLARE @V_COUNT INT;

   /* VARIAVEIS DO CURSOR AJUSTE */
   DECLARE @AJUSTE_CDFILIAL VARCHAR(04);
   DECLARE @AJUSTE_NRLANCTONF VARCHAR(10);
   DECLARE @AJUSTE_NRSEQVENPAG VARCHAR(02);
   DECLARE @AJUSTE_NRPARCELAPAG VARCHAR(02);
   DECLARE @AJUSTE_DTAJUSTEPAG DATETIME;
   DECLARE @AJUSTE_CDAJUCTPAG VARCHAR(04);
   DECLARE @AJUSTE_DSAJUCTPAG VARCHAR(20);
   DECLARE @AJUSTE_CDHISTPADR VARCHAR(04);
   DECLARE @AJUSTE_VRAJUSTEPAG FLOAT;
   DECLARE @AJUSTE_IDAJUCTPAG VARCHAR(01);
   DECLARE @AJUSTE_CDCONTCTBL VARCHAR(20);
   DECLARE @AJUSTE_CDFORNECED VARCHAR(21);
   DECLARE @AJUSTE_CDFILIRECE VARCHAR(04);

   DECLARE @V_FATOR INT;

  /* VARIAVEIS DO CURSOR RATAJU */
  DECLARE @RATAJU_CDCENTCUST VARCHAR(04);
  DECLARE @RATAJU_CDFIRATTPAJP VARCHAR(04);
  DECLARE @RATAJU_CDFILIAL VARCHAR(04);
  DECLARE @RATAJU_VRPERATTPAJP FLOAT;

  DECLARE @V_VRPARTIDA FLOAT;
  DECLARE @V_VRRAT FLOAT;

BEGIN
   DECLARE C_CONTAS CURSOR FOR
      SELECT CR.CDEMPRESA, CR.CDTPCTPAGAR, NF.CDFILIRECE, NF.CDFORNECED,
             NF.NRNOTAFISC, NF.DTENTRSAID, CR.VRORIGPAG, NF.IDSTATUS,
             TP.CDHISTPADR, TP.CDCONTCTBL, CR.VRATUAPAG
        FROM CONTAPAGAR CR, NOTAFISCAL NF, TIPOCTPAGAR TP LEFT JOIN HISTPADR H
                                                                     ON TP.CDHISTPADR = H.CDHISTPADR
       WHERE CR.CDFILIAL = @P_CDFILIAL
         AND CR.NRLANCTONF = @P_NRLANCTONF
         AND CR.NRSEQVENPAG = @P_NRSEQVENPAG
         AND CR.NRPARCELAPAG = @P_NRPARCELAPAG
         AND CR.CDFILIAL = NF.CDFILIAL
         AND CR.NRLANCTONF = NF.NRLANCTONF
         AND CR.CDTPCTPAGAR = TP.CDTPCTPAGAR
         AND TP.IDCTBLCTPAG = 'S';
   OPEN C_CONTAS;
   FETCH NEXT FROM C_CONTAS INTO @C_CONTAS_CDEMPRESA, @C_CONTAS_CDTPCTPAGAR, @C_CONTAS_CDFILIRECE, @C_CONTAS_CDFORNECED,
                                 @C_CONTAS_NRNOTAFISC, @C_CONTAS_DTENTRSAID, @C_CONTAS_VRORIGPAG, @C_CONTAS_IDSTATUS,
                                 @C_CONTAS_CDHISTPADR, @C_CONTAS_CDCONTCTBL, @C_CONTAS_VRATUAPAG;
   WHILE @@FETCH_STATUS = 0 BEGIN
      /* VERIFICA SE A EMPRESA RESPONSVEL PELA CONTA UTILIZA A  GEREO DE RATEIO DO LANAMENTO CONTBIL  N- NO S-SIM
         VERIFICA SE OS VALORES DE PARTIDAS IRO ACUMULAR, CASO A CONTA CONTBIL SEJA A MESMA*/
      SELECT @V_CONTRAT = IDCONTGERE
        FROM CONTOPECTBL
       WHERE CDEMPRESA = @C_CONTAS_CDEMPRESA;

      IF @C_CONTAS_IDSTATUS = 'A' BEGIN
         IF @P_NRLANCCTBTEMP IS NOT NULL BEGIN
            /* DELETA OS RATEIOS DO LANAMENTO CONTBIL */
            DELETE
              FROM LANCCCUSTO
             WHERE NRLANCCONT = @P_NRLANCCTBTEMP
               AND CDEMPRESA  = @C_CONTAS_CDEMPRESA;

            /* DELETA AS PARTIDAS DO LANAMENTO CONTBIL */
            DELETE
              FROM LANCCONT
             WHERE NRLANCCONT = @P_NRLANCCTBTEMP
               AND CDEMPRESA  = @C_CONTAS_CDEMPRESA;

         END;
         SET @V_NRLANCTEMP = @P_NRLANCCTBTEMP;

         SELECT @V_COUNT = COUNT(*)
           FROM PARAMCTBL
          WHERE @C_CONTAS_DTENTRSAID >= DTINTCTBPAG;

         IF @V_COUNT > 0 BEGIN
            /* DELETA TODOS OS REGISTROS TEMPORRIOS PARA ESSE LANAMENTO */
            DELETE FROM LANCCTBTEMP
             WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
               AND CDEMPRESA     = @C_CONTAS_CDEMPRESA;

            DELETE FROM RATECTBTEMP
             WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
               AND CDEMPRESA     = @C_CONTAS_CDEMPRESA;

            IF @P_IDTIPO = 'D' BEGIN

               /* CASO A VARIVEL QUE RECEBE O NMERO DO LANAMENTO CONTBIL SEJA NULA,  PORQUE O LANAMENTO CONTBIL  NOVO. */
               IF @V_NRLANCTEMP IS NULL BEGIN
                  /* PEGA UM NOVO NMERO DE LANAMENTO CONTBIL, CASO O LANAMENTO NO PAG SEJA NOVO */
                  SET @V_DATAAUX = CONVERT(VARCHAR, @C_CONTAS_DTENTRSAID, 103);
                  SET @V_DATAAUX = 'LANCCONTABIL' + @C_CONTAS_CDEMPRESA + SUBSTRING(@V_DATAAUX, 7, 4) + SUBSTRING(@V_DATAAUX, 4, 2);

                  EXEC NOVO_CODIGO @V_DATAAUX, @P_SEQUENCIAL = @V_NRLANCTEMP OUTPUT;

                  SET @V_DATAAUX = SUBSTRING(CONVERT(VARCHAR, @C_CONTAS_DTENTRSAID, 103), 7, 4);
                  SET @V_DATAAUX = @V_DATAAUX + SUBSTRING(CONVERT(VARCHAR, @C_CONTAS_DTENTRSAID, 103), 4, 2);

                  SET @V_NRLANCTEMP = @V_DATAAUX  + SUBSTRING(@V_NRLANCTEMP, 15, 6);
               END;

               /* BUSCA HISTORICO PADRAO DE INTEGRAO DO PAG*/
               SELECT @V_CDHISTPADR = HI.CDHISTPADR
                 FROM HISTINTEGRA HI, HISTPADR HP
                WHERE HI.CDHISTPADR = HP.CDHISTPADR
                  AND HI.CDOPERACAO = 'CTAPAG';

               /* VERIFICA SE EXISTE HISTORIO CADASTRADO NO TIPO DE CONTA, CASO NO EXISTA PEGA DO HISTORICO DE INTEGRAO PAG */
               IF @C_CONTAS_CDHISTPADR IS NOT NULL BEGIN
                  SET @V_CDHISTPADR = @C_CONTAS_CDHISTPADR;
               END;

               /* FORMATA A DESCRIO DO HISTRICO PADRO BUSCADO, DO TIPO DE CONTA OU DE INTEGRAO */
               EXEC CTB_HIST_PAG @V_CDHISTPADR, @P_CDFILIAL, @P_NRLANCTONF, @P_NRSEQVENPAG, @P_NRPARCELAPAG, @P_CDAJUCTPAG, @P_DSHISTPADR = @V_DSHISTLANC OUTPUT;

               /* CREDITO NA CONTA CONTABIL DE CLIENTE */
               EXEC CTB_CCFORNECEDOR @C_CONTAS_CDFORNECED, @C_CONTAS_CDFILIRECE, @C_CONTAS_CDEMPRESA, @P_CDCONTCTBL = @V_CDCONTCTBL OUTPUT;

               SELECT @V_IDTIPOCOME = ISNULL(IDTIPOCOME, 'N'), @V_IDCONTCCUS = ISNULL(IDCONTCCUS, 'L')
                 FROM CONTCTBL
                WHERE CDCONTCTBL = @V_CDCONTCTBL;

               SET @V_CDFORNECEDAUX = @C_CONTAS_CDFORNECED;
               IF @V_IDTIPOCOME <> 'F' BEGIN
                  SET @V_CDFORNECEDAUX = NULL;
                  SET @V_IDTIPOCOME   = 'N';
               END;

               INSERT INTO LANCCTBTEMP
                  (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                   DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
               VALUES
                  (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, @C_CONTAS_NRNOTAFISC, '00001', @V_CDCONTCTBL, @V_CDHISTPADR,
                   @V_DSHISTLANC, @C_CONTAS_DTENTRSAID, @C_CONTAS_VRORIGPAG, @V_IDTIPOCOME, @V_CDFORNECEDAUX, 'PAG');

               /* VERIFICA SE A EMPRESA GERA O RATEIO CONTBIL. */
               IF @V_CONTRAT = 'S' BEGIN
                  /* VERIFICA SE A CONTA NO  "S OFICIAL"*/
                  IF @V_IDCONTCCUS <> 'O' BEGIN
                     SELECT @V_CDCENTCUST = CDCENTCUST
                       FROM FILIAL
                      WHERE CDFILIAL = @C_CONTAS_CDFILIRECE;

                     IF @V_CDCENTCUST IS NULL BEGIN
                        SELECT @V_CDCENTCUST = CDCENTCUST
                          FROM EMPRESA
                         WHERE CDEMPRESA = @C_CONTAS_CDEMPRESA
                     END;
                     INSERT INTO RATECTBTEMP
                        (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                     VALUES
                        (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, '00001', @C_CONTAS_CDFILIRECE, @V_CDCENTCUST, @C_CONTAS_VRORIGPAG, @C_CONTAS_DTENTRSAID, '00001');
                  END;
               END;

               SET @V_ENTROULOOP = 'N';
               SET @V_INPARTIDA = 1;
               DECLARE C_RATCTPAGAR CURSOR FOR
                  SELECT CDCENTCUST, CDFIRATCTPAG, VRRATCCCTPAG, COUNT(*) OVER(PARTITION BY NRLANCTONF, CDFILIAL, NRPARCELAPAG, NRSEQVENPAG) AS RECORDCOUNT
                    FROM RATCTPAGAR
                   WHERE CDFILIAL     = @P_CDFILIAL
                     AND NRLANCTONF   = @P_NRLANCTONF
                     AND NRSEQVENPAG  = @P_NRSEQVENPAG
                     AND NRPARCELAPAG = @P_NRPARCELAPAG
                   GROUP BY CDCENTCUST, CDFIRATCTPAG, VRRATCCCTPAG, NRLANCTONF, CDFILIAL, NRPARCELAPAG, NRSEQVENPAG;
               OPEN C_RATCTPAGAR;
               FETCH NEXT FROM C_RATCTPAGAR INTO @C_RATCTPAGAR_CDCENTCUST,
                                                  @C_RATCTPAGAR_CDFIRATCTPAG,
                                                  @C_RATCTPAGAR_VRRATCCCTPAG,
                                                  @C_RATCTPAGAR_RECORDCOUNT;
               WHILE @@FETCH_STATUS = 0 BEGIN
                  IF @V_ENTROULOOP = 'N' BEGIN
                     SET @V_INCOUNT = 1;
                  END;

                  SET @V_ENTROULOOP = 'S';

                  SELECT @V_CDCONTCTBL = CDCONTCTBL
                    FROM TIPOCTPAGARFILI
                   WHERE CDFILIAL = @P_CDFILIAL
                     AND CDTPCTPAGAR = @C_CONTAS_CDTPCTPAGAR;

                  IF @V_CDCONTCTBL IS NULL BEGIN
                     SET @V_CDCONTCTBL = @C_CONTAS_CDCONTCTBL;
                  END;

                  SELECT @V_IDTIPOCOME = ISNULL(IDTIPOCOME, 'N'), @V_IDCONTCCUS = ISNULL(IDCONTCCUS, 'L')
                    FROM CONTCTBL
                   WHERE CDCONTCTBL = @V_CDCONTCTBL;

                  /* FAZ A MESMA VERIFICAO SE A CONTA CONTBIL  DO TIPO FORNECEDOR */
                  SET @V_CDFORNECEDAUX = @C_CONTAS_CDFORNECED;
                  IF @V_IDTIPOCOME <> 'F' BEGIN
                     SET @V_CDFORNECEDAUX = NULL;
                     SET @V_IDTIPOCOME = 'N';
                  END;

                  SELECT @V_COUNT = COUNT(*),@V_SEQUENCIAL = NRSEQCTBTEMP
                    FROM LANCCTBTEMP
                   WHERE CDEMPRESA = @C_CONTAS_CDEMPRESA
                     AND NRLANCCTBTEMP = @V_NRLANCTEMP
                     AND CDCONTCTBL = @V_CDCONTCTBL
                   GROUP BY NRSEQCTBTEMP;


                  SET @V_PERCENTUAL = (100 * @C_RATCTPAGAR_VRRATCCCTPAG) / @C_CONTAS_VRATUAPAG;
                  SET @V_PERCENTUAL = ROUND((@V_PERCENTUAL * @C_CONTAS_VRORIGPAG) / 100, 2);

                  SET @V_TOTAL = ROUND(@V_TOTAL - @V_PERCENTUAL, 2);
                  SET @V_PERCENTUAL = @V_PERCENTUAL * -1;
                  IF @V_COUNT = 0 BEGIN
                     SET @V_INPARTIDA = @V_INPARTIDA + 1;

                     SET @V_SEQUENCIAL = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_INPARTIDA), 2);
                     IF @V_INCOUNT = @C_RATCTPAGAR_RECORDCOUNT BEGIN
                        SET @V_PERCENTUAL = @V_PERCENTUAL + @V_TOTAL;
                     END;

                     INSERT INTO LANCCTBTEMP
                        (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                         DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
                     VALUES
                        (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, @C_CONTAS_NRNOTAFISC, @V_SEQUENCIAL, @V_CDCONTCTBL, @V_CDHISTPADR,
                         @V_DSHISTLANC, @C_CONTAS_DTENTRSAID, @V_PERCENTUAL, @V_IDTIPOCOME, @V_CDFORNECEDAUX, 'PAG');
                  END
                  ELSE BEGIN
                     UPDATE LANCCTBTEMP
                        SET VRLANCCTBTEMP = VRLANCCTBTEMP + (@V_PERCENTUAL)
                      WHERE CDEMPRESA = @C_CONTAS_CDEMPRESA
                        AND NRLANCCTBTEMP = @V_NRLANCTEMP
                        AND CDCONTCTBL = @V_CDCONTCTBL;
                  END;

                  IF @V_CONTRAT = 'S' BEGIN
                     /* VERIFICA SE A CONTA NO  "S OFICIAL"*/
                     IF @V_IDCONTCCUS <> 'O' BEGIN
                        IF @V_COUNT = 0 BEGIN
                           SET @V_SEQUENCIAL = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_INPARTIDA), 2);
                        END;
                        SELECT @V_COUNT = COUNT(*)
                          FROM RATECTBTEMP
                         WHERE CDEMPRESA = @C_CONTAS_CDEMPRESA
                           AND NRLANCCTBTEMP = @V_NRLANCTEMP
                           AND NRSEQCTBTEMP = @V_SEQUENCIAL
                           AND CDFILIAL = @C_RATCTPAGAR_CDFIRATCTPAG
                           AND CDCENTCUST = @C_RATCTPAGAR_CDCENTCUST;
                        IF @V_COUNT = 0 BEGIN
                           INSERT INTO RATECTBTEMP
                              (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                           VALUES
                              (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, @V_SEQUENCIAL, @C_RATCTPAGAR_CDFIRATCTPAG, @C_RATCTPAGAR_CDCENTCUST,
                               @V_PERCENTUAL, @C_CONTAS_DTENTRSAID, '00000');
                        END
                        ELSE BEGIN
                           UPDATE RATECTBTEMP
                              SET VRRATECTBTEMP = VRRATECTBTEMP + (@V_PERCENTUAL)
                            WHERE CDEMPRESA = @C_CONTAS_CDEMPRESA
                              AND NRLANCCTBTEMP = @V_NRLANCTEMP
                              AND NRSEQCTBTEMP = @V_SEQUENCIAL
                              AND CDFILIAL = @C_RATCTPAGAR_CDFIRATCTPAG
                              AND CDCENTCUST = @C_RATCTPAGAR_CDCENTCUST;
                        END;
                     END;
                  END;
                  SET @V_INCOUNT = @V_INCOUNT + 1;
                  FETCH NEXT FROM C_RATCTPAGAR INTO @C_RATCTPAGAR_CDCENTCUST,
                                   @C_RATCTPAGAR_CDFIRATCTPAG,
                                   @C_RATCTPAGAR_VRRATCCCTPAG,
                                   @C_RATCTPAGAR_RECORDCOUNT;
               END;
               CLOSE C_RATCTPAGAR;
               DEALLOCATE C_RATCTPAGAR;

               IF @V_ENTROULOOP = 'N' BEGIN
                  SET @V_CDCONTCTBL = @C_CONTAS_CDCONTCTBL;

                  SELECT @V_IDTIPOCOME = ISNULL(IDTIPOCOME, 'N'), @V_IDCONTCCUS = ISNULL(IDCONTCCUS, 'L')
                    FROM CONTCTBL
                   WHERE CDCONTCTBL = @V_CDCONTCTBL;

                  /* FAZ A MESMA VERIFICAO SE A CONTA CONTBIL  DO TIPO FORNECEDOR */
                  SET @V_CDFORNECEDAUX = @C_CONTAS_CDFORNECED;
                  IF @V_IDTIPOCOME <> 'F' BEGIN
                     SET @V_CDFORNECEDAUX = NULL;
                     SET @V_IDTIPOCOME = 'N';
                  END;

                  SET @V_INPARTIDA = @V_INPARTIDA + 1;
                  SET @V_SEQUENCIAL = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_INPARTIDA), 2);
                  SET @V_VRPARTIDA = @C_CONTAS_VRORIGPAG * -1;
                  INSERT INTO LANCCTBTEMP
                     (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                      DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
                  VALUES
                     (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, @C_CONTAS_NRNOTAFISC, @V_SEQUENCIAL, @V_CDCONTCTBL, @V_CDHISTPADR,
                      @V_DSHISTLANC, @C_CONTAS_DTENTRSAID, @V_VRPARTIDA, @V_IDTIPOCOME, @V_CDFORNECEDAUX, 'PAG');

                  IF @V_CONTRAT = 'S' BEGIN
                     /* VERIFICA SE A CONTA NO  "S OFICIAL"*/
                     IF @V_IDCONTCCUS <> 'O' BEGIN
                        SELECT @V_CDCENTCUST = CDCENTCUST
                          FROM FILIAL
                         WHERE CDFILIAL = @C_CONTAS_CDFILIRECE;

                        IF @V_CDCENTCUST IS NULL BEGIN
                           SELECT @V_CDCENTCUST = CDCENTCUST
                             FROM EMPRESA
                            WHERE CDEMPRESA = @C_CONTAS_CDEMPRESA
                        END;
                        INSERT INTO RATECTBTEMP
                           (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                        VALUES
                           (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, @V_SEQUENCIAL, @C_CONTAS_CDFILIRECE, @V_CDCENTCUST,  @V_VRPARTIDA, @C_CONTAS_DTENTRSAID, '00000');
                     END;
                  END;
               END;

               /*VERIFICACAO DE ERROS NAS PARTIDAS E NO LANCAMENTO CONTABIL*/
               EXEC VERIFICA_ERRO_CTB @V_NRLANCTEMP, @C_CONTAS_CDEMPRESA;

               SELECT @V_COUNT = ISNULL(COUNT(*), 0)
                 FROM ERROCTBTEMP
                WHERE CDEMPRESA = @C_CONTAS_CDEMPRESA
                  AND NRLANCCTBTEMP = @V_NRLANCTEMP;
               /* SE O LANAMENTO NO TER ERROS,  GRAVADO O NMERO DE LANAMENTO CONTBIL NA NOTA FISCAL */
               IF @V_COUNT = 0 BEGIN
                  UPDATE NOTAFISCAL
                     SET NRLANCTBDOC = @V_NRLANCTEMP
                   WHERE NRLANCTONF  = @P_NRLANCTONF
                     AND CDFILIAL    = @P_CDFILIAL;
               END;

            END
            ELSE IF @P_IDTIPO = 'A' BEGIN
               /*----------------------------------------------------------------------*/
               /* Contabilizao de ajuste da aba ajuste da tela de contas a a PAGAR */
               /*----------------------------------------------------------------------*/

               /* CASO A VARIVEL QUE RECEBE O NMERO DO LANAMENTO CONTBIL SEJA NULA,  PORQUE O LANAMENTO CONTBIL  NOVO. */
               IF @V_NRLANCTEMP IS NULL BEGIN
                  /* PEGA UM NOVO NMERO DE LANAMENTO CONTBIL, CASO O AJUSTE NO PAG SEJA NOVO */
                  SET @V_DATAAUX = CONVERT(VARCHAR, @P_DTAJUSTEPAG, 103);
                  SET @V_DATAAUX = 'LANCCONTABIL' + @C_CONTAS_CDEMPRESA + SUBSTRING(@V_DATAAUX, 7, 4) + SUBSTRING(@V_DATAAUX, 4, 2);

                  EXEC NOVO_CODIGO @V_DATAAUX, @P_SEQUENCIAL = @V_NRLANCTEMP OUTPUT;

                  SET @V_DATAAUX = SUBSTRING(CONVERT(VARCHAR, @P_DTAJUSTEPAG, 103), 7, 4);
                  SET @V_DATAAUX = @V_DATAAUX + SUBSTRING(CONVERT(VARCHAR, @P_DTAJUSTEPAG, 103), 4, 2);

                  SET @V_NRLANCTEMP = @V_DATAAUX  + SUBSTRING(@V_NRLANCTEMP, 15, 6);

               END;

               DECLARE AJUSTE CURSOR FOR
                  SELECT A.CDFILIAL, A.NRLANCTONF, A.NRSEQVENPAG, A.NRPARCELAPAG,
                         A.DTAJUSTEPAG, A.CDAJUCTPAG, T.DSAJUCTPAG, T.CDHISTPADR,
                         ROUND(A.VRAJUSTEPAG, 2) VRAJUSTEPAG, T.IDAJUCTPAG, T.CDCONTCTBL,
                         NF.CDFORNECED, NF.CDFILIRECE
                   FROM AJCTPAGAR A, NOTAFISCAL NF, TIPOAJPAGAR T LEFT JOIN HISTPADR H
                                                                             ON T.CDHISTPADR = H.CDHISTPADR
                  WHERE A.CDFILIAL = @P_CDFILIAL
                    AND A.NRLANCTONF = @P_NRLANCTONF
                    AND A.NRSEQVENPAG = @P_NRSEQVENPAG
                    AND A.NRPARCELAPAG = @P_NRPARCELAPAG
                    AND A.DTAJUSTEPAG = @P_DTAJUSTEPAG
                    AND A.CDAJUCTPAG = @P_CDAJUCTPAG
                    AND A.CDAJUCTPAG = T.CDAJUCTPAG
                    AND NF.CDFILIAL = A.CDFILIAL
                    AND NF.NRLANCTONF = A.NRLANCTONF
                  ORDER BY A.CDFILIAL, A.NRLANCTONF, A.CDAJUCTPAG;
               OPEN AJUSTE;
               FETCH NEXT FROM AJUSTE INTO @AJUSTE_CDFILIAL, @AJUSTE_NRLANCTONF, @AJUSTE_NRSEQVENPAG, @AJUSTE_NRPARCELAPAG,
                                           @AJUSTE_DTAJUSTEPAG, @AJUSTE_CDAJUCTPAG, @AJUSTE_DSAJUCTPAG, @AJUSTE_CDHISTPADR,
                                           @AJUSTE_VRAJUSTEPAG, @AJUSTE_IDAJUCTPAG, @AJUSTE_CDCONTCTBL, @AJUSTE_CDFORNECED,
                                           @AJUSTE_CDFILIRECE;
               WHILE @@FETCH_STATUS = 0 BEGIN
                  /* VERIFICA SE  UM AJUSTE DE DESCONTO OU ACRSCIMO */
                  IF @AJUSTE_IDAJUCTPAG = 'D' BEGIN
                     SET @V_FATOR = -1;
                  END
                  ELSE BEGIN
                     SET @V_FATOR = 1;
                  END;

                  SET @V_CDHISTPADR = @AJUSTE_CDHISTPADR;

                  EXEC CTB_HIST_PAG @V_CDHISTPADR, @P_CDFILIAL, @P_NRLANCTONF, @P_NRSEQVENPAG, @P_NRPARCELAPAG, @P_CDAJUCTPAG, @P_DSHISTPADR = @V_DSHISTLANC OUTPUT;

                  EXEC CTB_CCFORNECEDOR @AJUSTE_CDFORNECED, @C_CONTAS_CDFILIRECE, @C_CONTAS_CDEMPRESA, @P_CDCONTCTBL = @V_CDCONTCTBL OUTPUT;

                  SELECT @V_IDTIPOCOME = ISNULL(IDTIPOCOME, 'N'), @V_IDCONTCCUS = ISNULL(IDCONTCCUS, 'L')
                    FROM CONTCTBL
                   WHERE CDCONTCTBL = @V_CDCONTCTBL;

                  SET @V_CDFORNECEDAUX = @C_CONTAS_CDFORNECED;

                  /* CASO A CONTA CONTBIL NO SEJA DO TIPO CLIENTE, A PARTIDA SER SEM CIDGO COMERCIAL */
                  IF @V_IDTIPOCOME <> 'F' BEGIN
                     SET @V_CDFORNECEDAUX = NULL;
                     SET @V_IDTIPOCOME = 'N';
                  END;

                  SET @V_VRPARTIDA = @AJUSTE_VRAJUSTEPAG * -1 * @V_FATOR;
                  INSERT INTO LANCCTBTEMP
                     (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                      DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
                  VALUES
                     (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, @C_CONTAS_NRNOTAFISC, '00001', @V_CDCONTCTBL, @V_CDHISTPADR,
                      @V_DSHISTLANC, @AJUSTE_DTAJUSTEPAG, @V_VRPARTIDA, @V_IDTIPOCOME, @V_CDFORNECEDAUX, 'PAG');

                  /* VERIFICA SE A EMPRESA CONTROLA O RATEIO CONTBIL */
                  IF @V_CONTRAT = 'S' BEGIN
                     /* VERIFICA SE A CONTA CONTBIL NO  "S OFICIAL" */
                     IF @V_IDCONTCCUS <> 'O' BEGIN
                        SELECT @V_CDCENTCUST = CDCENTCUST
                          FROM FILIAL
                         WHERE CDFILIAL = @C_CONTAS_CDFILIRECE;

                        IF @V_CDCENTCUST IS NULL BEGIN
                           SELECT @V_CDCENTCUST = CDCENTCUST
                             FROM EMPRESA
                            WHERE CDEMPRESA = @C_CONTAS_CDEMPRESA
                        END;
                        SET @V_VRRAT = @AJUSTE_VRAJUSTEPAG * @V_FATOR * -1;
                        INSERT INTO RATECTBTEMP
                           (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                        VALUES
                           (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, '00001', @C_CONTAS_CDFILIRECE, @V_CDCENTCUST, @V_VRRAT, @AJUSTE_DTAJUSTEPAG, '00001');
                     END;
                  END;

                  /* CREDITA NO TIPO DE AJUSTE */
                  SELECT @V_IDTIPOCOME = ISNULL(IDTIPOCOME, 'N'), @V_IDCONTCCUS = ISNULL(IDCONTCCUS, 'L')
                    FROM CONTCTBL
                   WHERE CDCONTCTBL = @V_CDCONTCTBL;

                  /* GUARDA O CDIGO DO CLIENTE */
                  SET @V_CDFORNECEDAUX = @AJUSTE_CDFORNECED;

                  /* SE A CONTA CONTBIL FOR DIFERENTE DE CLIENTE,  FEITA A PARTIDA SEM CDIGO COMERCIAL */
                  IF @V_IDTIPOCOME <> 'F' BEGIN
                     SET @V_IDTIPOCOME = 'N';
                     SET @V_CDFORNECEDAUX = NULL;
                  END;

                  SET @V_VRPARTIDA = @AJUSTE_VRAJUSTEPAG * @V_FATOR;
                  INSERT INTO LANCCTBTEMP
                     (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                      DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
                  VALUES
                     (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, @C_CONTAS_NRNOTAFISC, '00002', @AJUSTE_CDCONTCTBL, @V_CDHISTPADR,
                      @V_DSHISTLANC, @AJUSTE_DTAJUSTEPAG, @V_VRPARTIDA, @V_IDTIPOCOME, @V_CDFORNECEDAUX, 'PAG');

                  /* VERIFICA SE A EMPRESA CONTROLA RATEIO CONTBIL */
                  IF @V_CONTRAT = 'S' BEGIN
                     /* SE A CONTA CONTBIL FOR DIFERENTE DE "S OFICIAL", SO FEITOS OS RATEIOS NECESSRIOS */
                     IF @V_IDCONTCCUS <> 'O' BEGIN
                        SET @V_ENTROULOOP = 'N';
                        SET @V_RATSEQ = 1;

                        SET @V_VRRATEIO = 0;
                        /* PEGA OS CENTROS DE CUSTOSM FILIALS E PERCENTUAIS CADASTRADOS NA TELA */
                        DECLARE RATAJU CURSOR FOR
                           SELECT CDCENTCUST, CDFIRATTPAJP, CDFILIAL, VRPERATTPAJP
                              FROM RATTPAJP
                             WHERE CDAJUCTPAG = @P_CDAJUCTPAG;
                        OPEN RATAJU;
                        FETCH NEXT FROM RATAJU INTO @RATAJU_CDCENTCUST, @RATAJU_CDFIRATTPAJP,
                                                    @RATAJU_CDFILIAL, @RATAJU_VRPERATTPAJP;

                        WHILE @@FETCH_STATUS = 0 BEGIN
                           SET @V_ENTROULOOP = 'S';

                           /* FAZ O SOMATRIO DOS RATEIOS DE ACORDO COM OS PERCENTUAIS INFORMADOS NA TELA
                              PARA VERIFICAR SE EXISTE DIFERENA DE ARREDONDAMENTO POSTERIORMENTE */
                           SET @V_VRRATEIO = @V_VRRATEIO + ROUND(((@AJUSTE_VRAJUSTEPAG * @V_FATOR)* @RATAJU_VRPERATTPAJP) /100, 2);
                           SET @V_VRRAT = ROUND(((@AJUSTE_VRAJUSTEPAG * @V_FATOR)* @RATAJU_VRPERATTPAJP) /100, 2);

                           IF @RATAJU_CDFIRATTPAJP = '----' BEGIN
                              SET @V_CDFILIAL = @AJUSTE_CDFILIRECE;
                           END
                           ELSE BEGIN
                              SET @V_CDFILIAL = @RATAJU_CDFIRATTPAJP;
                           END;

                           SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);
                           /* CASO TENHA FILIAL CADASTRADA NA TELA,  FEITO O RATEIO PARA ESSA FILIAL */
                           INSERT INTO RATECTBTEMP
                             (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                           VALUES
                              (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, '00002', @V_CDFILIAL, @RATAJU_CDCENTCUST,
                               @V_VRRAT, @AJUSTE_DTAJUSTEPAG, @V_RATSEQAUX);

                           SET @V_CDCENTCUST = @RATAJU_CDCENTCUST;
                           SET @V_RATSEQ = @V_RATSEQ + 1;

                           FETCH NEXT FROM RATAJU INTO @RATAJU_CDCENTCUST, @RATAJU_CDFIRATTPAJP,
                                                       @RATAJU_CDFILIAL, @RATAJU_VRPERATTPAJP;
                        END;
                        CLOSE RATAJU;
                        DEALLOCATE RATAJU;

                        IF @V_ENTROULOOP = 'S' BEGIN
                           /* VERIFICA SE O VALOR TOTAL RATEADO  IGUAL AO VEALOR DO AJUSTE, CASO NO SEJA,  FEITO
                              O RATEIO PARA A LTIMA FILIAL E CENTRO DE CUSTO */
                           IF @V_VRRATEIO <> (@AJUSTE_VRAJUSTEPAG * @V_FATOR) BEGIN
                              SET @V_VRRATEIO = (@AJUSTE_VRAJUSTEPAG * @V_FATOR) - @V_VRRATEIO;
                              UPDATE RATECTBTEMP
                                 SET VRRATECTBTEMP = VRRATECTBTEMP + @V_VRRATEIO
                               WHERE CDEMPRESA     = @C_CONTAS_CDEMPRESA
                                 AND NRLANCCTBTEMP = @V_NRLANCTEMP
                                 AND NRSEQCTBTEMP  = '00002'
                                 AND CDFILIAL      = @V_CDFILIAL
                                 AND CDCENTCUST    = @V_CDCENTCUST;
                           END;
                        END;

                        IF @V_ENTROULOOP = 'N' BEGIN
                           SELECT @V_CDCENTCUST = CDCENTCUST
                             FROM FILIAL
                            WHERE CDFILIAL = @C_CONTAS_CDFILIRECE;

                           IF @V_CDCENTCUST IS NULL BEGIN
                              SELECT @V_CDCENTCUST = CDCENTCUST
                                FROM EMPRESA
                               WHERE CDEMPRESA = @C_CONTAS_CDEMPRESA
                           END;
                           /* CASO NO TENHA RATEIO CADASTRADO NA TELA DE PARAMETROS PARA CENTRO DE CUSTO,  FEITO O RATEIO
                              PARA A FILIAL DE EMISSO DA CONTA DO AJUSTE */
                           SET @V_VRRAT = ROUND(@AJUSTE_VRAJUSTEPAG * @V_FATOR, 2);
                           SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);
                           INSERT INTO RATECTBTEMP
                             (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                           VALUES
                              (@C_CONTAS_CDEMPRESA, @V_NRLANCTEMP, '00002', @C_CONTAS_CDFILIRECE, @V_CDCENTCUST,
                              @V_VRRAT, @AJUSTE_DTAJUSTEPAG, @V_RATSEQAUX);
                        END
                     END;
                  END;

                  FETCH NEXT FROM AJUSTE INTO @AJUSTE_CDFILIAL, @AJUSTE_NRLANCTONF, @AJUSTE_NRSEQVENPAG, @AJUSTE_NRPARCELAPAG,
                                              @AJUSTE_DTAJUSTEPAG, @AJUSTE_CDAJUCTPAG, @AJUSTE_DSAJUCTPAG, @AJUSTE_CDHISTPADR,
                                              @AJUSTE_VRAJUSTEPAG, @AJUSTE_IDAJUCTPAG, @AJUSTE_CDCONTCTBL, @AJUSTE_CDFORNECED,
                                              @AJUSTE_CDFILIRECE;
               END;
               CLOSE AJUSTE;
               DEALLOCATE AJUSTE;
               /*VERIFICACAO DE ERROS NAS PARTIDAS E NO LANCAMENTO CONTABIL*/
               EXEC VERIFICA_ERRO_CTB @V_NRLANCTEMP, @C_CONTAS_CDEMPRESA;
               SELECT @V_COUNT = COUNT(*)
                 FROM ERROCTBTEMP
                WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
                  AND CDEMPRESA = @C_CONTAS_CDEMPRESA;

               /* CASO NO TENHA GERADO ERRO NA ROTINA DE CONTABILIZAO, O NMERO DE LANAMENTO  GRAVADO NO AJUSTE. */
               IF @V_COUNT = 0 BEGIN
                  IF @P_NRLANCCTBTEMP IS NULL BEGIN
                     UPDATE AJCTPAGAR
                        SET NRLCTBAJPAG = @V_NRLANCTEMP
                      WHERE CDFILIAL     = @P_CDFILIAL
                        AND NRLANCTONF   = @P_NRLANCTONF
                        AND NRSEQVENPAG  = @P_NRSEQVENPAG
                        AND NRPARCELAPAG = @P_NRPARCELAPAG
                        AND DTAJUSTEPAG  = @P_DTAJUSTEPAG
                        AND CDAJUCTPAG   = @P_CDAJUCTPAG;
                  END;
               END;
            END;
         END;
      END;

      SET @P_NRLANCCTB = @V_NRLANCTEMP;
      /* TRMINO DAS PARTIDAS DO LANCAMENTO CONTABIL*/
       /* GRAVA O LANAMENTO TEMPORRIO SE NO CONTER ERRO NA LANCCONT E LANCCUSTO, APS GRAVAR IR APAGAR O LANCAMENTO TEMPORRIO */
      EXEC GRAVA_LANC_CTB @V_NRLANCTEMP, @C_CONTAS_CDEMPRESA;
      FETCH NEXT FROM C_CONTAS INTO @C_CONTAS_CDEMPRESA, @C_CONTAS_CDTPCTPAGAR, @C_CONTAS_CDFILIRECE, @C_CONTAS_CDFORNECED,
                                   @C_CONTAS_NRNOTAFISC, @C_CONTAS_DTENTRSAID, @C_CONTAS_VRORIGPAG, @C_CONTAS_IDSTATUS,
                                   @C_CONTAS_CDHISTPADR, @C_CONTAS_CDCONTCTBL, @C_CONTAS_VRATUAPAG;
   END;
   CLOSE C_CONTAS;
   DEALLOCATE C_CONTAS;
END;
GO


-- VERSAO --
EXEC TEKNISA.ATUVEROBJ 'CTB_PAG_LANC','5.55.xxx';
GO

